##-------------------------------------------------------------------
## Modified from Abandon Raze City by unknown, Bhruic, Nemo, OrionVetran, Rise of Mankind
##  by Dancing Hoskuld with a great deal of help from EmperorFool
##  to work in, with and under BUG
##-------------------------------------------------------------------
##
## Things that could be done to improve this mod making it interact with the main mod in a more generic fashon.
## 1. replace the English language stuff with the correct language translations in the text file.
##-------------------------------------------------------------------
##
## To get this working in any mod you need to
## 1. put 	<load mod="Abandon City Mod"/>	in the init.xml in the Python/Config directory
##-------------------------------------------------------------------
##
## Changes
##  April 2009
##	A moders section of this code now allows a single place for the setting of the "parameters"
##	 - produce just workers or settlers and workers
##	 - produce 1 worker for every X popuation in the city
##	 - produce 1 settler fo every X population in the city with 1 worker for every Y in the remainder
##   Sell buildings rather than demolish them.  Thanks Zappara
##   Unhappiness from selling religious buildings +1 unhappy for x turns.  Where x depends on game speed.
##   Can not abandon last city.
##   Can not sell free buildings however they need to appear in the list for this program to work.
##
##   Note. If you only have one city and it has no buildings then Ctrl-A will appear not to work.  This was
##   done to to stop a CDT which could be caused otherwise.  Besides there is nothing to sell and you can't
##   abandon your only city.
##-------------------------------------------------------------------
##
## Potential changes
## 1. has an .ini file (AbandonCity.INI) to hold parameters
##	 - active/inactive
##
## 2. UU workers if they exist.
## 3. buildings in albhabetical order in the list.
##
## ------------------------------------------
## Decided not to generate upgraded settler units as these could then be settled and the free buildings sold off.
##
## Decided to have the population parameters in the code for modders rather than letting the player change them ad hoc.
##
## Decided that you can sell obsolete buildings.  Just because they are obsolete does not mean that they are not having an effect.



from CvPythonExtensions import *
import CvUtil
import CvEventInterface
import PyHelpers
import Popup as PyPopup
import BugCore
import BugUtil
import SdToolKit
import autolog
import string
import StandardFunctions

# globals

SD_MOD_ID = "AbandonCity"

ABANDON_CITY_DEMOLISH_BUILDING_EVENT_ID = CvUtil.getNewEventID("AbandonCity.Active")

gc = CyGlobalContext()
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo

#AbandonCityOpt = BugCore.game.AbandonCity
g_modEventManager = None
g_eventMgr = None
g_autolog = None

# "parameters for modders.
bSettlersAndWorkers = True # "True means settlers and workers are produced.  False to just produce workers.
iPopulationForSettlers = 10 # If producing settlers then produce 1 per each full city population of iPopulationForSettlers
iPopulationForWorkers = 3  # produce 1 per each full city population of iPopulationForWorkers. 
						   # Note: this is left over population after producing settlers if any.


def onStartAbandonCity(argsList):
	g_modEventManager.onStartAbandonCity(argsList)

class AbandonCityEvents:
	def __init__(self, eventManager):
		eventManager.addEventHandler("StartAbandonCity", self.onStartAbandonCity)

		global g_modEventManager
		g_modEventManager = self

		global g_autolog
		g_autolog = autolog.autologInstance()
		
		global g_eventMgr
		g_eventMgr = eventManager
		self.eventManager = eventManager
		

		eventManager.setPopupHandler(ABANDON_CITY_DEMOLISH_BUILDING_EVENT_ID, ("AbandonCity.Active", self.__eventAbandonCityDestroyBuildingApply, self.__eventAbandonCityDestroyBuildingBegin))

# Rise of Mankind 2.7
		global g_ConstructModifier
		g_ConstructModifier = 1
		global g_CostFraction
		g_CostFraction = 0.2 # 20% of base value
		
		# must be higher than sum of building classes + all modular building classes (getNumBuildingClassInfos function ignores modular buildings)
		global g_iAbandonTrigger
		g_iAbandonTrigger = 1000
# Rise of Mankind 2.7

	def onStartAbandonCity(self, argsList):
 		#have keypress from handler - return 1 if the event was consumed
		#CyInterface().addImmediateMessage("Abandon City Demolish Building - __StartAbandonCity called", None)

		game = gc.getGame()
		

		if ( CyInterface().isCityScreenUp() ):
			if (CyInterface().getHeadSelectedCity().getOwner() == gc.getGame().getActivePlayer()):
				## if no buildings and only one city then do not display popup
				pHeadSelectedCity = CyInterface().getHeadSelectedCity()
				pPlayer = gc.getPlayer(pHeadSelectedCity.getOwner())
				g_eventMgr.beginEvent(ABANDON_CITY_DEMOLISH_BUILDING_EVENT_ID)
				return 1
		return 0

	def __eventAbandonCityDestroyBuildingBegin(self, argsList):
		#CyInterface().addImmediateMessage("Abandon City Demolish Building - __eventAbandonCityDestroyBuildingBegin called", None)
		pHeadSelectedCity = CyInterface().getHeadSelectedCity()
		pPlayer = gc.getPlayer(pHeadSelectedCity.getOwner())
		civ = gc.getCivilizationInfo(pPlayer.getCivilizationType())
		
		header = BugUtil.getPlainText("TXT_KEY_ABANDON_CITY_HEADER")
		abandoncity = BugUtil.getPlainText("TXT_KEY_ABANDON_CITY")
		ok = BugUtil.getPlainText("TXT_KEY_MAIN_MENU_OK")
		cancel = BugUtil.getPlainText("TXT_KEY_POPUP_CANCEL")
		popup = PyPopup.PyPopup(ABANDON_CITY_DEMOLISH_BUILDING_EVENT_ID, EventContextTypes.EVENTCONTEXT_ALL)
		popup.setHeaderString(header)
		popup.createPullDown()

		# find out what the gamespeed building cost modifier is
		# and adjust construct modifier also with building production percent game define
		iGameSpeed = gc.getGame().getGameSpeedType()
		iBuildProdPercent = gc.getDefineINT("BUILDING_PRODUCTION_PERCENT")/100
		g_ConstructModifier = iBuildProdPercent*gc.getGameSpeedInfo(iGameSpeed).getConstructPercent()/100
		
		# Loop through BuildingClassInfos
		for i in range(0,gc.getNumBuildingClassInfos()):
			iType = civ.getCivilizationBuildings(i)
			# Check for Holy Shrines so that player can't demolish them 
			if (iType > 0 and pHeadSelectedCity.isHasBuilding(iType) and not isWorldWonderClass(gc.getBuildingInfo(iType).getBuildingClassType()) and not gc.getBuildingInfo(iType).getGlobalReligionCommerce() > 0):
				# Figure gold based on cost, zero for free buildings
				if pPlayer.isBuildingFree(iType) == True:
					iGoldBack = 0
					szBuilding = gc.getBuildingInfo(iType).getDescription()
					szBuilding += " (" + localText.getText("TXT_KEY_ABANDON_FREE", ())
				else:
					# is there some 3rd global modifier which affects building cost because the gold is lower than the 20%, inflation, handicap, world size?
					iGoldBack = int(gc.getBuildingInfo(iType).getProductionCost() * g_ConstructModifier * g_CostFraction)
					szBuilding = gc.getBuildingInfo(iType).getDescription()
					szBuilding += " (" + u"%d " %(iGoldBack) + localText.getText("TXT_KEY_COMMERCE_GOLD", ())
				# Add unhappiness text here
				if gc.getBuildingInfo(iType).getReligionType() >= 0 : # religious building
				    szBuilding += ", " + localText.getText("TXT_KEY_ABANDON_UNHAPPINESS", ()) 
				szBuilding += ")"
		 
				popup.addPullDownString(szBuilding, iType)


		# Only allow abandonment of city if there is more than one city
		if pPlayer.getNumCities() > 1 :
			popup.addPullDownString(abandoncity, g_iAbandonTrigger)

		popup.addButton(ok)
		popup.addButton(cancel)
		popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)
		return

	def __eventAbandonCityDestroyBuildingApply(self, playerID, userData, popupReturn):
		#CyInterface().addImmediateMessage("Abandon City Demolish Building - __eventAbandonCityDestroyBuildingApply called", None)
		pPlayer = gc.getPlayer(playerID)
		civ = gc.getCivilizationInfo(pPlayer.getCivilizationType())
		pHeadSelectedCity = CyInterface().getHeadSelectedCity()
		doTraitCheck = False
				
		if (popupReturn.getButtonClicked() == 0):
			# changed abandoncity to use global integer value in case mod has modular buildings which aren't counted for some reason...
			# player chooses to abandon the city, should this affect unhappiness among those culture areas that have citizens in this city?
			
			if (popupReturn.getSelectedPullDownValue(0) == g_iAbandonTrigger):
				ix = pHeadSelectedCity.getX()
				iy = pHeadSelectedCity.getY()
				ipopulation = CyInterface().getHeadSelectedCity().getPopulation()

				#Call the onCityRazed event to do whatever the other mods do when a city is raised
				# according to http://www.apolyton.net/forums/showthread.php?t=140611
				# the argsList for CityRazed are: city, iPlayer
				CvEventInterface.getEventManager().fireEvent("cityRazed", pHeadSelectedCity, playerID)

				# Abandon the City
				pHeadSelectedCity.kill()
				CyAudioGame().Play2DSound("AS2D_DISCOVERBONUS")

				# Generate the units
				# get the indices for the units being created (Settlers and Workers
				indexWorker = gc.getInfoTypeForString("UNIT_WORKER")
				indexSettler = gc.getInfoTypeForString("UNIT_SETTLER")
				indexSettlerWagon = gc.getInfoTypeForString("UNIT_SETTLER_WAGON")
				iGunPowderTech = gc.getInfoTypeForString("TECH_GUNPOWDER")
				# check civ's unique units
				iUniqueWorkerUnit = civ.getCivilizationUnits(indexWorker)
				
				if gc.getTeam(pPlayer.getTeam()).isHasTech(iGunPowderTech):
					iUniqueSettlerUnit = civ.getCivilizationUnits(indexSettlerWagon)
				
				if not gc.getTeam(pPlayer.getTeam()).isHasTech(iGunPowderTech):
					iUniqueSettlerUnit = civ.getCivilizationUnits(indexSettler)
				
				# if Settlers and Workers
				if bSettlersAndWorkers == True:
					isettlers = ipopulation/iPopulationForSettlers
					iworkers = (ipopulation - iPopulationForSettlers * isettlers)/iPopulationForWorkers
				else:
					isettlers = 0
					iworkers = ipopulation/iPopulationForWorkers

				for i in range(0,iworkers):
					pPlayer.initUnit(iUniqueWorkerUnit, ix, iy, UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
				for i in range(0,isettlers):
					pPlayer.initUnit(iUniqueSettlerUnit, ix, iy, UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
			
			else:
				iBuildingType = popupReturn.getSelectedPullDownValue(0)
				iType = civ.getCivilizationBuildings(gc.getBuildingInfo(iBuildingType).getBuildingClassType())

				# if building is not free, demolish and calculate gold amount, else we don't need to do anything
				if pPlayer.isBuildingFree(iType) == False:
					# Figure gold based on cost, zero for free buildings
					iGoldBack = int(gc.getBuildingInfo(iType).getProductionCost() * g_ConstructModifier * g_CostFraction)
					pPlayer.changeGold(iGoldBack)
					# unhappiness penalty when demolishing any religion buildings
					if gc.getBuildingInfo(iType).getReligionType() >= 0 : # religious building
						pHeadSelectedCity.changeHurryAngerTimer(pHeadSelectedCity.flatHurryAngerLength())
					
					if gc.getBuildingInfo(iType).getSpecialBuildingType() == gc.getInfoTypeForString("SPECIALBUILDING_MYSTERIES"):
						doTraitCheck = True
					
					pHeadSelectedCity.setNumRealBuilding(iType, False)
					CyAudioGame().Play2DSound("AS2D_DISCOVERBONUS")
					CyInterface().setDirty(InterfaceDirtyBits.CityScreen_DIRTY_BIT, True)
					CyInterface().setDirty(InterfaceDirtyBits.SelectionButtons_DIRTY_BIT, True)
					iGoldBack = 0
					
					# Compare number of Traits against the number of Mystery Wonders
					if doTraitCheck:
						TotalMysteries = StandardFunctions.getMysteryCount(playerID) + 2
						intTraitCount = 0
						
						for iTrait in range(gc.getNumTraitInfos()):
							if not iTrait == None:
								if pPlayer.hasTrait(iTrait) == True:
									intTraitCount += 1
						
						if intTraitCount > TotalMysteries:
							for iTrait in range(gc.getNumTraitInfos()):
								if not iTrait == None:
									if not gc.getLeaderHeadInfo(pPlayer.getLeaderType()).hasTrait(iTrait):
										if pPlayer.hasTrait(iTrait) == True:
											pPlayer.setHasTrait((iTrait), False)
											break
					
		return
