# Sid Meier's Civilization 4
# Copyright Firaxis Games 2005
# Orion's Ice Breaker Mod
from CvPythonExtensions import *
import BugUtil
import BugCore
import CvUtil
import CvTechChooser
import traceback
import os
import sys
import PyHelpers
import pickle
import CvGameUtils
import CvEventInterface
import CvWBPopups
import Popup as PyPopup
import StandardFunctions
import math


# for C++ compatibility
false=False
true=True

# globals
gc = CyGlobalContext()
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
PyCity = PyHelpers.PyCity
PyGame = PyHelpers.PyGame
ArtFileMgr = CyArtFileMgr()
	
	
def getIceBreakerProductionChance(AIpPlayer):
	# Accelerates Ice Breaker production for sea faring traits
	iTrait = gc.getInfoTypeForString("TRAIT_TRAIT_SEAFARING")
	
	if (AIpPlayer.hasTrait(iTrait)):
		# SEAFARING Players get a 33% chance for Producing an Ice Breaker
		return 33
		
	# Non SEAFARING Players get a 16% chance for Producing an Ice Breaker
	return 16
# End Orion's Ice Breaker Mod Functions

