# Sid Meier's Civilization 4
# Copyright Firaxis Games 2006
# 
# IceBreakerEvents
#
from CvPythonExtensions import *
import CvUtil
import CvScreensInterface
import CvDebugTools
import CvWBPopups
import PyHelpers
import Popup as PyPopup
import CvCameraControls
import CvTopCivs
import sys
import CvWorldBuilderScreen
import CvAdvisorUtils
import CvTechChooser
import IceBreaker
import StandardFunctions


# for C++ compatibility
false=False
true=True

# globals
gc = CyGlobalContext()
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo


class IceBreakerEvents:
	def __init__(self, eventMgr):
		self.__LOG_MOVEMENT = 0
		self.__LOG_UNITBUILD = 0
		self.__LOG_UNITBUILD = 0
		self.eventMgr = eventMgr
		
		eventMgr.addEventHandler("unitBuilt", self.onUnitBuilt)
	
	def onUnitBuilt(self, argsList):
		'Unit Completed'
		city = argsList[0]
		unit = argsList[1]
		player = PyPlayer(city.getOwner())
# IceBreaker Mod
		iUnitType = unit.getUnitType()
		AIpPlayer = gc.getPlayer(city.getOwner())
		
		if not AIpPlayer.isNone() and not AIpPlayer.isBarbarian() and not AIpPlayer.isHuman( ) and AIpPlayer.isAlive():
			# Ice Breaker Mod
			if not gc.getGame().isOption(GameOptionTypes.GAMEOPTION_OGI_NO_ICE_BREAKERS):
				# Is this an IceBreaker?
				if iUnitType == gc.getInfoTypeForString("UNIT_ICE_BREAKER"):
					#CyInterface().addImmediateMessage("Do Mine Sweeper Placement", "")
					unit.doAIIceBreakerPlacement()
			
# End Mine Warfare Mod

